<?xml version="1.0"  encoding="UTF-8"?>
<!-- =======================================================================
XRadar
Copyright (c) 2004, 2005, Kristoffer Kvam
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
Neither the name of Kristoffer Kvam nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See licence.txt for dependancies to other open projects. 
======================================================================= -->
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xalan="http://xml.apache.org/xalan">



<!-- Page HEADER -->
<xsl:template name="page-header">
    <xsl:param name="main-menu-page-name"/>
    <xsl:param name="page-name"/>
    <xsl:param name="statics-page-name" select="'overview'"/>
    <xsl:param name="page-type"/>
    <xsl:param name="single-package"/>
    <xsl:param name="subsystem-name" select="''"/>
    <xsl:param name="package-name" select="''"/>

  <xsl:variable name="statics-url">
      <xsl:choose>
          <xsl:when test="$subsystem-name != ''"><xsl:value-of select="concat($statics-root,'/subsystems/overview-subsystem-',$subsystem-name,'.html')"/></xsl:when>
          <xsl:when test="$package-name != ''"><xsl:value-of select="concat($statics-root,'/packages/overview-package-',$package-name,'.html')"/></xsl:when>
          <xsl:otherwise><xsl:value-of select="concat($statics-root,'/scorecard-',$statics-page-name,'.html')"/></xsl:otherwise>
      </xsl:choose>
  </xsl:variable>

  <table width="100%">
	  <tr>

        <td valign="top" align="left">
        </td>
        <td align="right" rowspan="2">
            <img src="../img/xradar-basic-sign.jpg"/>
        </td>
    </tr>
    <tr>
        <td valign="bottom" align="left">
            <h1><a href="http://xradar.sourceforge.net">http://xradar.sourceforge.net</a></h1>
        </td>
    </tr>
  </table>
  <hr size="1"/>
  <table width="100%">
	  <tr>
	    <td align="left"><b>Dynamics Report</b></td>
	      <td align="right">Designed for use with
		      <xsl:for-each select="/radar-report/sources/source">
		      	<a target="_new">
		      		<xsl:attribute name="href">
		      			<xsl:value-of select="@link"/>
		      		</xsl:attribute>
		      		<xsl:value-of select="."/>
		      	</a>,
		      </xsl:for-each>
              <a href="http://www.java2html.de/" target="_new">Java2HTML</a>
		      and
		      <a href="http://ant.apache.org" target="_new">Ant</a>.
	      </td>
	  </tr>
  </table>
  <hr size="1"/>

    <table width="100%">
        <tr>
            <td colspan="2">
                <h2>
                    [<xsl:if test="$statics-configured = 'true'">
                        <a href="{$statics-url}">Statics</a> /
                    </xsl:if>Dynamics]
                    <xsl:value-of select="$page-name"/>
                </h2>
            </td>
        </tr>
        <tr>
            <td></td>
            <td align="right">
                <b>
                    <xsl:choose>
                        <xsl:when test="$main-menu-page-name = 'scorecard'">
                    [scorecard]
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:variable name="overview-link">
                                <xsl:call-template name="overview-link">
                                    <xsl:with-param name="single-package" select="$single-package"/>
                                    <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                                    <xsl:with-param name="package-name" select="$package-name"/>
                                </xsl:call-template>
                            </xsl:variable>
                    [
                            <a>
                                <xsl:attribute name="href">
                                    <xsl:value-of select="$overview-link"/>
                                </xsl:attribute>scorecard
                            </a>]
                        </xsl:otherwise>
                    </xsl:choose>
                    <xsl:choose>
                        <xsl:when test="$main-menu-page-name = 'analysis'">
                    [analysis]
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:variable name="classes-analysis-link">
                                <xsl:call-template name="classes-analysis-link">
                                    <xsl:with-param name="single-package" select="$single-package"/>
                                    <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                                    <xsl:with-param name="package-name" select="$package-name"/>
                                </xsl:call-template>
                            </xsl:variable>
                    [
                            <a>
                                <xsl:attribute name="href">
                                    <xsl:value-of select="$classes-analysis-link"/>
                                </xsl:attribute>analysis
                            </a>]
                        </xsl:otherwise>
                    </xsl:choose>
                </b>
            </td>
        </tr>
        <tr>
            <td></td>
            <td align="right">
                <xsl:call-template name="sub-menu">
                    <xsl:with-param name="main-menu-page-name" select="$main-menu-page-name"/>
                    <xsl:with-param name="page-type" select="$page-type"/>
                    <xsl:with-param name="single-package" select="$single-package"/>
                    <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                    <xsl:with-param name="package-name" select="$package-name"/>
                </xsl:call-template>
            </td>
        </tr>
    </table>
</xsl:template>

<xsl:template name="sub-menu">
    <xsl:param name="main-menu-page-name" select="'scorecard'"/>
    <xsl:param name="page-type"/>
    <xsl:param name="single-package"/>
    <xsl:param name="subsystem-name"/>
    <xsl:param name="package-name"/>

    <xsl:choose>
        <xsl:when test="($main-menu-page-name = 'scorecard') or ($main-menu-page-name = '') or not($main-menu-page-name)">
            <xsl:choose>
                <xsl:when test="$page-type = 'overview'">
                    {overview}
                </xsl:when>
                <xsl:otherwise>
                    <xsl:variable name="overview-link">
                        <xsl:call-template name="overview-link">
                            <xsl:with-param name="single-package" select="$single-package"/>
                            <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                            <xsl:with-param name="package-name" select="$package-name"/>
                        </xsl:call-template>
                    </xsl:variable>
                    {<a><xsl:attribute name="href"><xsl:value-of select="$overview-link"/></xsl:attribute>overview</a>}
                </xsl:otherwise>
            </xsl:choose>

            <xsl:choose>
                <xsl:when test="$page-type = 'architecture'">
                    {architecture}
                </xsl:when>
                <xsl:otherwise>
                    <xsl:variable name="architecture-link">
                        <xsl:choose>
                            <xsl:when test="$single-package='true'">architecture-package-<xsl:value-of select="$package-name"/>.html</xsl:when>
                            <xsl:when test="$subsystem-name=''">architecture-system.html</xsl:when>
                            <xsl:otherwise>architecture-subsystem-<xsl:value-of select="$subsystem-name"/>.html</xsl:otherwise>
                        </xsl:choose>
                    </xsl:variable>
                    {<a><xsl:attribute name="href"><xsl:value-of select="$architecture-link"/></xsl:attribute>architecture</a>}
                </xsl:otherwise>
            </xsl:choose>
			
			<xsl:choose>
                <xsl:when test="$page-type = 'package-design'">
                    {design}
                </xsl:when>
                <xsl:otherwise>
                    <xsl:variable name="design-link">
                        <xsl:choose>
                            <xsl:when test="$single-package='true'">package-design-package-<xsl:value-of select="$package-name"/>.html</xsl:when>
                            <xsl:when test="$subsystem-name=''">package-design-system.html</xsl:when>
                            <xsl:otherwise>package-design-subsystem-<xsl:value-of select="$subsystem-name"/>.html</xsl:otherwise>
                        </xsl:choose>
                    </xsl:variable>
                    {<a><xsl:attribute name="href"><xsl:value-of select="$design-link"/></xsl:attribute>design</a>}
                </xsl:otherwise>
            </xsl:choose>
			
            <xsl:choose>
                <xsl:when test="$page-type = 'code'">
                    {code}
                </xsl:when>
                <xsl:otherwise>
                    <xsl:variable name="code-link">
                        <xsl:choose>
                            <xsl:when test="$single-package='true'">code-package-<xsl:value-of select="$package-name"/>.html</xsl:when>
                            <xsl:when test="$subsystem-name=''">code-system.html</xsl:when>
                            <xsl:otherwise>code-subsystem-<xsl:value-of select="$subsystem-name"/>.html</xsl:otherwise>
                        </xsl:choose>
                    </xsl:variable>
                    {<a><xsl:attribute name="href"><xsl:value-of select="$code-link"/></xsl:attribute>code</a>}
                </xsl:otherwise>
            </xsl:choose>

            <xsl:choose>
                <xsl:when test="$page-type = 'test'">
                    {test}
                </xsl:when>
                <xsl:otherwise>
                    <xsl:variable name="test-link">
                        <xsl:choose>
                            <xsl:when test="$single-package='true'">test-package-<xsl:value-of select="$package-name"/>.html</xsl:when>
                            <xsl:when test="$subsystem-name=''">test-system.html</xsl:when>
                            <xsl:otherwise>test-subsystem-<xsl:value-of select="$subsystem-name"/>.html</xsl:otherwise>
                        </xsl:choose>
                    </xsl:variable>
                    {<a><xsl:attribute name="href"><xsl:value-of select="$test-link"/></xsl:attribute>test</a>}
                </xsl:otherwise>
            </xsl:choose>

            <xsl:choose>
                <xsl:when test="$page-type = 'source control'">
                    {source control}
                </xsl:when>
                <xsl:otherwise>
                    <xsl:variable name="source-control-link">
                        <xsl:choose>
                            <xsl:when test="$single-package='true'">source-control-package-<xsl:value-of select="$package-name"/>.html</xsl:when>
                            <xsl:when test="$subsystem-name=''">source-control-system.html</xsl:when>
                            <xsl:otherwise>source-control-subsystem-<xsl:value-of select="$subsystem-name"/>.html</xsl:otherwise>
                        </xsl:choose>
                    </xsl:variable>
                    {<a><xsl:attribute name="href"><xsl:value-of select="$source-control-link"/></xsl:attribute>source control</a>}
                </xsl:otherwise>
            </xsl:choose>

            <xsl:choose>
                <xsl:when test="$page-type = 'system specific'">
                    {system specific}
                </xsl:when>
                <xsl:otherwise>
                    <xsl:variable name="system-specific-link">
                        <xsl:choose>
                            <xsl:when test="$single-package='true'">system-specific-package-<xsl:value-of select="$package-name"/>.html</xsl:when>
                            <xsl:when test="$subsystem-name=''">system-specific-system.html</xsl:when>
                            <xsl:otherwise>system-specific-subsystem-<xsl:value-of select="$subsystem-name"/>.html</xsl:otherwise>
                        </xsl:choose>
                    </xsl:variable>
                    {<a><xsl:attribute name="href"><xsl:value-of select="$system-specific-link"/></xsl:attribute>system specific</a>}
                </xsl:otherwise>
            </xsl:choose>
        </xsl:when>

        <xsl:when test="$main-menu-page-name = 'analysis'">
            <xsl:choose>
                <xsl:when test="$page-type = 'class analysis'">
                    {class analysis}
                </xsl:when>
                <xsl:otherwise>
                    <xsl:variable name="classes-analysis-link">
                        <xsl:call-template name="classes-analysis-link">
                            <xsl:with-param name="single-package" select="$single-package"/>
                            <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                            <xsl:with-param name="package-name" select="$package-name"/>
                        </xsl:call-template>
                    </xsl:variable>
                    {<a><xsl:attribute name="href"><xsl:value-of select="$classes-analysis-link"/></xsl:attribute>class analysis</a>}
                </xsl:otherwise>
            </xsl:choose>
            <xsl:choose>
                <xsl:when test="$page-type = 'method analysis'">
                    {complex methods analysis}
                </xsl:when>
                <xsl:otherwise>
                    <xsl:variable name="methods-analysis-link">
                        <xsl:choose>
                            <xsl:when test="$single-package='true'">methods-analysis-package-<xsl:value-of select="$package-name"/>.html</xsl:when>
                            <xsl:when test="$subsystem-name=''">methods-analysis-system.html</xsl:when>
                            <xsl:otherwise>methods-analysis-subsystem-<xsl:value-of select="$subsystem-name"/>.html</xsl:otherwise>
                        </xsl:choose>
                    </xsl:variable>
                    {<a><xsl:attribute name="href"><xsl:value-of select="$methods-analysis-link"/></xsl:attribute>complex methods analysis</a>}
                </xsl:otherwise>
             </xsl:choose>
             <xsl:choose>
                <xsl:when test="$page-type = 'methods changed since last version analysis'">
                    {changed methods analysis}
                </xsl:when>
                <xsl:otherwise>
                    <xsl:variable name="methods-changed-since-last-version-analysis-link">
                        <xsl:choose>
                            <xsl:when test="$single-package='true'">methods-changed-since-last-version-analysis-package-<xsl:value-of select="$package-name"/>.html</xsl:when>
                            <xsl:when test="$subsystem-name=''">methods-changed-since-last-version-analysis-system.html</xsl:when>
                            <xsl:otherwise>methods-changed-since-last-version-analysis-subsystem-<xsl:value-of select="$subsystem-name"/>.html</xsl:otherwise>
                        </xsl:choose>
                    </xsl:variable>
                    {<a><xsl:attribute name="href"><xsl:value-of select="$methods-changed-since-last-version-analysis-link"/></xsl:attribute>changed methods analysis</a>}
                </xsl:otherwise>
             </xsl:choose>
        </xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="overview-link">
    <xsl:param name="single-package"/>
    <xsl:param name="subsystem-name"/>
    <xsl:param name="package-name"/>
    <xsl:choose>
        <xsl:when test="$single-package='true'">overview-package-<xsl:value-of select="$package-name"/>.html</xsl:when>
        <xsl:when test="$subsystem-name=''">overview-system.html</xsl:when>
        <xsl:otherwise>overview-subsystem-<xsl:value-of select="$subsystem-name"/>.html</xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="classes-analysis-link">
    <xsl:param name="single-package"/>
    <xsl:param name="subsystem-name"/>
    <xsl:param name="package-name"/>
    <xsl:choose>
        <xsl:when test="$single-package='true'">classes-analysis-package-<xsl:value-of select="$package-name"/>.html</xsl:when>
        <xsl:when test="$subsystem-name=''">classes-analysis-system.html</xsl:when>
        <xsl:otherwise>classes-analysis-subsystem-<xsl:value-of select="$subsystem-name"/>.html</xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="standard-dynamics-line-graph">
	<xsl:param name="text-y-axis"/>
	<xsl:param name="primary-metric-group"/>
	<xsl:param name="primary-metric"/>
    <!-- optional 1-->
    <xsl:param name="divisor-metric-group"/>
    <xsl:param name="divisor-metric"/>
    <xsl:param name="multiplier" select="'1'"/>
	<!-- optional 2-->
	<xsl:param name="package-count-divisor" select="'false'"/>

    <xsl:param name="reports-element"/>
	<xsl:param name="packages-element"/>
	<xsl:param name="subsystem-name"/>
	<xsl:param name="single-package"/>
	<xsl:param name="package-element"/>
	<xsl:param name="y-axis-justification" select="'10-percent-normalize'"/>

	<xsl:call-template name="line-graph">
  		<xsl:with-param name="text-x-axis" select="'Version'"/>
  		<xsl:with-param name="text-y-axis" select="$text-y-axis"/>
  		<xsl:with-param name="width" select="'1300'"/>
  		<xsl:with-param name="height" select="'800'"/>
  		<xsl:with-param name="point-nodeset">
  			<points>
	  			<xsl:for-each select="$reports-element/report">
	  				<xsl:sort data-type="number" select="@seq-id"/>
	  				<xsl:variable name="current-seq-id" select="@seq-id"/>
	  				<xsl:choose>
						<xsl:when test="$single-package='true'">
					 		<xsl:if test="$package-element/statistics/source-metrics/ncss/value[@seq-id=$current-seq-id]">
				  				<point>
				  					<x-label><xsl:value-of select="version"/></x-label>
				  					<x-coordinate><xsl:value-of select="sum(../report[@seq-id &lt;= $current-seq-id]/days-since-last)"/></x-coordinate>
                                    <xsl:choose>
                                        <xsl:when test="$divisor-metric">
                                            <xsl:variable name="divisor"><xsl:choose><xsl:when test="sum($package-element/statistics/node()[name() = $divisor-metric-group]/node()[name() = $divisor-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value) &gt; 0">
														<xsl:value-of select="sum($package-element/statistics/node()[name() = $divisor-metric-group]/node()[name() = $divisor-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)"/></xsl:when><xsl:otherwise>1</xsl:otherwise></xsl:choose>
													</xsl:variable>
                                            <y-coordinate><xsl:value-of select="$multiplier * sum($package-element/statistics/node()[name() = $primary-metric-group]/node()[name() = $primary-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)
                                                div $divisor"/></y-coordinate>
                                        </xsl:when>
										<xsl:when test="$package-count-divisor = 'true'">
                                            <y-coordinate><xsl:value-of select="$multiplier * sum($package-element/statistics/node()[name() = $primary-metric-group]/node()[name() = $primary-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)"/></y-coordinate>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <y-coordinate><xsl:value-of select="$multiplier * sum($package-element/statistics/node()[name() = $primary-metric-group]/node()[name() = $primary-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)"/></y-coordinate>
                                        </xsl:otherwise>
                                    </xsl:choose>
				  				</point>
		  					</xsl:if>
						</xsl:when>
				        <xsl:otherwise>
				            <xsl:if test="$packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/source-metrics/ncss/value[@seq-id=$current-seq-id]">
				  				<point>
				  					<x-label><xsl:value-of select="version"/></x-label>
				  					<x-coordinate><xsl:value-of select="sum(../report[@seq-id &lt;= $current-seq-id]/days-since-last)"/></x-coordinate>
				  					<xsl:choose>
                                        <xsl:when test="$divisor-metric">
                                            <xsl:variable name="divisor"><xsl:choose><xsl:when test="sum($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/node()[name() = $divisor-metric-group]/node()[name() = $divisor-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value) &gt; 0">
														<xsl:value-of select="sum($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/node()[name() = $divisor-metric-group]/node()[name() = $divisor-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)"/></xsl:when><xsl:otherwise>1</xsl:otherwise></xsl:choose>
													</xsl:variable>
                                            <y-coordinate><xsl:value-of select="$multiplier * sum($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/node()[name() = $primary-metric-group]/node()[name() = $primary-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)
                                                div $divisor"/></y-coordinate>
                                        </xsl:when>
										<xsl:when test="$package-count-divisor = 'true'">
                                            <y-coordinate><xsl:value-of select="$multiplier * sum($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/node()[name() = $primary-metric-group]/node()[name() = $primary-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)
                                                div count($packages-element/package[starts-with(@subsystem,$subsystem-name)]/package-availability/report[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')])"/></y-coordinate>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <y-coordinate><xsl:value-of select="$multiplier * sum($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/node()[name() = $primary-metric-group]/node()[name() = $primary-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)"/></y-coordinate>
                                        </xsl:otherwise>
                                    </xsl:choose>
				  				</point>
		  					</xsl:if>
				        </xsl:otherwise>
				    </xsl:choose>
	  			</xsl:for-each>
  			</points>
			<xsl:if test="not($single-package='true')">
				<xsl:if test="$subsystem-name=''">
					<subcomponents>
						<xsl:for-each select="//subsystems/subsystem[not(@name ='')]">							
							<xsl:variable name="this-subsystem-name" select="@name"/>
							<component name="{@name}">
								<points>
									<xsl:for-each select="$reports-element/report">
										  <xsl:sort data-type="number" select="@seq-id"/>
										  <xsl:variable name="current-seq-id" select="@seq-id"/>
										  <point>
											<x-label><xsl:value-of select="version"/></x-label>
											<x-coordinate><xsl:value-of select="sum(../report[@seq-id &lt;= $current-seq-id]/days-since-last)"/></x-coordinate>
											<xsl:choose>
												<xsl:when test="$divisor-metric">
													<xsl:variable name="divisor"><xsl:choose><xsl:when test="sum($packages-element/package[starts-with(@subsystem,$this-subsystem-name)]/statistics/node()[name() = $divisor-metric-group]/node()[name() = $divisor-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value) &gt; 0">
														<xsl:value-of select="sum($packages-element/package[starts-with(@subsystem,$this-subsystem-name)]/statistics/node()[name() = $divisor-metric-group]/node()[name() = $divisor-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)"/></xsl:when><xsl:otherwise>1</xsl:otherwise></xsl:choose>
													</xsl:variable>	
													<y-coordinate><xsl:value-of select="$multiplier * sum($packages-element/package[starts-with(@subsystem,$this-subsystem-name)]/statistics/node()[name() = $primary-metric-group]/node()[name() = $primary-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)
													div $divisor"/></y-coordinate>
												</xsl:when>
												<xsl:when test="$package-count-divisor = 'true'">
													<xsl:variable name="divisor"><xsl:choose><xsl:when test="count($packages-element/package[starts-with(@subsystem,$this-subsystem-name)]/package-availability/report[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]) &gt; 0">
														<xsl:value-of select="count($packages-element/package[starts-with(@subsystem,$this-subsystem-name)]/package-availability/report[@seq-id=$current-seq-id])"/></xsl:when><xsl:otherwise>1</xsl:otherwise></xsl:choose>
													</xsl:variable>																														
													<y-coordinate><xsl:value-of select="$multiplier * sum($packages-element/package[starts-with(@subsystem,$this-subsystem-name)]/statistics/node()[name() = $primary-metric-group]/node()[name() = $primary-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)
													div $divisor"/></y-coordinate>
												</xsl:when>													
												<xsl:otherwise>
													<y-coordinate><xsl:value-of select="$multiplier * sum($packages-element/package[starts-with(@subsystem,$this-subsystem-name)]/statistics/node()[name() = $primary-metric-group]/node()[name() = $primary-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)"/></y-coordinate>
												</xsl:otherwise>
											</xsl:choose>
										</point>		
									</xsl:for-each>
								</points>
							</component>
						</xsl:for-each>		
					</subcomponents>
				</xsl:if>
			</xsl:if>
			<xsl:if test="not($single-package='true')">
				<xsl:if test="not($subsystem-name='')">
					<subcomponents>
						<xsl:for-each select="//packages/package[(@subsystem =$subsystem-name)]">
							<xsl:variable name="this-package" select="current()"/>
							<component name="{@name}">
								<points>
									<xsl:for-each select="$reports-element/report">
										  <xsl:sort data-type="number" select="@seq-id"/>
										  <xsl:variable name="current-seq-id" select="@seq-id"/>
										  <point>
											<x-label><xsl:value-of select="version"/></x-label>
											<x-coordinate><xsl:value-of select="sum(../report[@seq-id &lt;= $current-seq-id]/days-since-last)"/></x-coordinate>
											<xsl:choose>
												<xsl:when test="$divisor-metric">
													<xsl:variable name="divisor"><xsl:choose><xsl:when test="sum($this-package/statistics/node()[name() = $divisor-metric-group]/node()[name() = $divisor-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value) &gt; 0">
														<xsl:value-of select="sum($this-package/statistics/node()[name() = $divisor-metric-group]/node()[name() = $divisor-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)"/></xsl:when><xsl:otherwise>1</xsl:otherwise></xsl:choose>
													</xsl:variable>
													<y-coordinate><xsl:value-of select="$multiplier * sum($this-package/statistics/node()[name() = $primary-metric-group]/node()[name() = $primary-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)
													div $divisor"/></y-coordinate>
												</xsl:when>
												<xsl:when test="$package-count-divisor = 'true'">
													<xsl:variable name="divisor"><xsl:choose><xsl:when test="count($this-package/package-availability/report[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]) &gt; 0">
														<xsl:value-of select="count($this-package/package-availability/report[@seq-id=$current-seq-id])"/></xsl:when><xsl:otherwise>1</xsl:otherwise></xsl:choose>
													</xsl:variable>
													<y-coordinate><xsl:value-of select="$multiplier * sum($this-package/statistics/node()[name() = $primary-metric-group]/node()[name() = $primary-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)
													div $divisor"/></y-coordinate>
												</xsl:when>
												<xsl:otherwise>
													<y-coordinate><xsl:value-of select="$multiplier * sum($this-package/statistics/node()[name() = $primary-metric-group]/node()[name() = $primary-metric]/value[(@seq-id=$current-seq-id) and not(@value='NaN') and not(@value='')]/@value)"/></y-coordinate>
												</xsl:otherwise>
											</xsl:choose>
										</point>
									</xsl:for-each>
								</points>
							</component>
						</xsl:for-each>
					</subcomponents>
				</xsl:if>
			</xsl:if>
  		</xsl:with-param>
  		<xsl:with-param name="y-axis-justification" select="$y-axis-justification"/>
	</xsl:call-template>

</xsl:template>
	
</xsl:stylesheet>
