<?xml version="1.0"  encoding="UTF-8"?>
<!-- =======================================================================
XRadar
Copyright (c) 2004, 2005, Kristoffer Kvam
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
Neither the name of Kristoffer Kvam nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See licence.txt for dependancies to other open projects. 
======================================================================= -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">      
   
    <!-- standard root template -->
    <xsl:template
    match="/">
      <IntegratedAnalysis>
      	 <xsl:for-each select="IntegratedAnalysis/@*">
      	 	<xsl:copy/>
      	 </xsl:for-each>	
         <xsl:copy-of select="IntegratedAnalysis/source"/>
         <xsl:element name="source">         	
         	<xsl:attribute name="link">
         		<xsl:value-of select="$report-source-link"/>	
         	</xsl:attribute>
         	<xsl:value-of select="$report-source"/>
         </xsl:element>
         
         <Packages>
         <xsl:apply-templates
          select="IntegratedAnalysis/Packages"/>
         </Packages> 

      </IntegratedAnalysis>
   </xsl:template>
   
   <!-- used for package tree match -->
   <xsl:template
    match="Packages">
      <xsl:for-each
       select="Package">
         
            <xsl:copy>               
	      		<xsl:apply-templates select="@*|node()"/>	      		
	      		<xsl:call-template name="package-addition"/>                               
            </xsl:copy>            
         
      </xsl:for-each>
   </xsl:template>
	
	<!-- Copy all nodes from here. Can be overridden by a more specific XPath -->
	<xsl:template match="@*|node()">
	   <xsl:copy>
	      <xsl:apply-templates select="@*|node()"/>
	   </xsl:copy>
	</xsl:template>
	
	
	<xsl:template name="extract-package-from-path">
		<xsl:param name="path"/>
		<xsl:param name="root-path"/>
		<xsl:variable name="subdir-path">
			<xsl:call-template name="extract-filename-from-path">
				<xsl:with-param name="path" select="$path"/>
			</xsl:call-template>	
		</xsl:variable>
		<xsl:value-of select="substring-after($subdir-path,root-path)"/>				
   </xsl:template>
   
   	
   <xsl:template name="extract-subdir-from-path">
   		<xsl:param name="path"/>
		<xsl:variable name="file-name">
			<xsl:call-template name="extract-filename-from-path">
				<xsl:with-param name="path" select="$path"/>
			</xsl:call-template>	
		</xsl:variable>				
		<xsl:value-of select="substring-before($path,concat('/',$file-name))"/>
   </xsl:template>
   
   
   <xsl:template name="extract-filename-from-path">
	  <xsl:param name="path"/>
	  <xsl:choose>
	     <xsl:when test="contains($path, '\')">
	        <xsl:call-template name="extract-filename-from-path">
	           <xsl:with-param name="path" select="substring-after($path, '\')"/>
	        </xsl:call-template>
	     </xsl:when>
	     <xsl:otherwise>
	        <xsl:value-of select="$path"/>
	     </xsl:otherwise>
	  </xsl:choose>
	</xsl:template>
	
	 
   
   
</xsl:stylesheet>
	
